VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "MSE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

Public Function Calculate(ByRef gxptTarget As Variant, _
                          ByRef gxptOutput As Variant, _
                          ByRef gxptParams As Variant, _
                          ByRef gxptModelInfo As Variant) As Variant

    Dim nSamples As Long: nSamples = gxptParams(0)
    Dim fitness As Double
    Dim modelMinusTargetSquared As Double
    Dim MSE As Double
    Dim temp1 As Double
    Dim i As Long
        
    For i = 0 To nSamples - 1
    
        temp1 = 0
        temp1 = gxptOutput(i) - gxptTarget(i)
        temp1 = temp1 * temp1
        modelMinusTargetSquared = modelMinusTargetSquared + temp1
    Next

    MSE = modelMinusTargetSquared / nSamples

    If MSE <= 0.000000001 Then
        MSE = 0#
    End If

    Calculate = (1 / (1 + MSE)) * 1000
    
End Function

